﻿@{
    var grid = Html.DevExpress().GridView(
    settings =>
    {
        settings.Name = "grdData";
        settings.KeyFieldName = "FieldName";
        settings.CallbackRouteValues = new { Controller = "DownloadTools", Action = "GridViewPartial" };
        settings.SettingsEditing.UpdateRowRouteValues = new { Controller = "DownloadTools", Action = "UpdatePartial" };
        settings.SettingsEditing.Mode = GridViewEditingMode.EditFormAndDisplayRow;
        settings.Styles.Header.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        settings.CommandColumn.Visible = true;
        settings.CommandColumn.EditButton.Visible = true;
        settings.ClientSideEvents.RowClick = "function (s, e) { grdData.StartEditRow(e.visibleIndex); }";
        settings.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
        settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);

        settings.Columns.Add("FieldName");
        settings.Columns.Add("DisplayName");
        settings.Columns.Add(col =>
        {
            col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            col.FieldName = "OrderDisplay";
            col.Name = "OrderDisplay";
            col.Caption = "Order Display";
        });
        settings.Columns.Add("PK", MVCxGridViewColumnType.CheckBox);
        settings.Columns.Add("DataType").CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        settings.Columns.Add("Criteria");
        settings.Columns.Add("DisplayOption", MVCxGridViewColumnType.CheckBox);
        settings.Columns.Add("Sort").CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;

        settings.SetEditFormTemplateContent(c =>
        {
            var user = ViewData["EditableTable"] != null ? ViewData["EditableTable"] : c.DataItem;
            ViewContext.Writer.Write(
                "<div class=\"edit_form\">" +
                "<div class=\"line\">"
            );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                    edtSettings.Text = "Field Name:";
                    edtSettings.AssociatedControlName = "FieldName";
                }
            )
            .Render();
            Html.DevExpress().TextBox(
                edtSettings =>
                {
                    edtSettings.Name = "FieldName";
                    edtSettings.ControlStyle.CssClass = "editor";
                    edtSettings.ShowModelErrors = true;
                    edtSettings.Enabled = false;
                }
            )
            .Bind(DataBinder.Eval(user, "FieldName"))
            .Render();

            ViewContext.Writer.Write(
                    "</div>" +
                    "<div class=\"line\">"
                );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                    edtSettings.Text = "Display Name:";
                    edtSettings.AssociatedControlName = "DisplayName";
                }
            )
            .Render();
            Html.DevExpress().TextBox(
                edtSettings =>
                {
                    edtSettings.Name = "DisplayName";
                    edtSettings.ControlStyle.CssClass = "editor";
                    edtSettings.ShowModelErrors = true;
                }
            )
            .Bind(DataBinder.Eval(user, "DisplayName"))
            .Render();

            ViewContext.Writer.Write(
                    "</div>" +
                    "<div class=\"line\">"
                );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                    edtSettings.Text = "Order Display:";
                    edtSettings.AssociatedControlName = "OrderDisplay";
                }
            )
            .Render();
            Html.DevExpress().SpinEdit(
                edtSettings =>
                {
                    edtSettings.Name = "OrderDisplay";
                    edtSettings.ControlStyle.CssClass = "editor";
                    edtSettings.Properties.NumberType = SpinEditNumberType.Integer;
                    edtSettings.Properties.MinValue = 1;
                    edtSettings.Properties.MaxValue = 100;
                    edtSettings.ShowModelErrors = true;
                }
            )
            .Bind(DataBinder.Eval(user, "OrderDisplay"))
            .Render();

            ViewContext.Writer.Write(
                    "</div>" +
                    "<div class=\"line\">"
                );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                }
            )
            .Render();
            Html.DevExpress().CheckBox(
                        edtSettings =>
                        {
                            edtSettings.Name = "PK";
                            edtSettings.ControlStyle.CssClass = "checkEditor";
                            edtSettings.Text = "PK";
                            edtSettings.ShowModelErrors = true;
                        }
                    )
            .Bind(DataBinder.Eval(user, "PK"))
            .Render();

            ViewContext.Writer.Write(
                    "</div>" +
                    "<div class=\"line\">"
                );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                    edtSettings.Text = "Data Type:";
                    edtSettings.AssociatedControlName = "DataType";
                }
            )
            .Render();
            Html.DevExpress().TextBox(
                edtSettings =>
                {
                    edtSettings.Name = "DataType";
                    edtSettings.ControlStyle.CssClass = "editor";
                    edtSettings.ShowModelErrors = true;
                    edtSettings.Enabled = false;
                }
            )
            .Bind(DataBinder.Eval(user, "DataType"))
            .Render();
            ViewContext.Writer.Write(
                    "</div>" +
                    "<div class=\"line\">"
                );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                    edtSettings.Text = "Criteria:";
                    edtSettings.AssociatedControlName = "Criteria";
                }
            )
            .Render();
            Html.DevExpress().ComboBox(
                    edtSettings =>
                        {
                            edtSettings.Name = "Comparison";
                            edtSettings.Width = 60;
                            edtSettings.Properties.Items.Add(" = ");
                            edtSettings.Properties.Items.Add(" <> ");
                            edtSettings.Properties.Items.Add(" like ");
                            edtSettings.Properties.Items.Add("<=");
                            edtSettings.Properties.Items.Add(">=");
                        }
                ).Bind(DataBinder.Eval(user, "Comparison"))
                .Render();
            Html.DevExpress().TextBox(
                edtSettings =>
                {
                    edtSettings.Name = "Criteria";
                    edtSettings.ControlStyle.CssClass = "editor";
                    edtSettings.ShowModelErrors = true;
                }
            )
            .Bind(DataBinder.Eval(user, "Criteria"))
            .Render();

            ViewContext.Writer.Write(
                    "</div>" +
                    "<div class=\"line\">"
                );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                }
            )
            .Render();
            Html.DevExpress().CheckBox(
                        edtSettings =>
                        {
                            edtSettings.Name = "DisplayOption";
                            edtSettings.ControlStyle.CssClass = "checkEditor";
                            edtSettings.Text = "Disp Option";
                            edtSettings.ShowModelErrors = true;
                        }
                    )
            .Bind(DataBinder.Eval(user, "DisplayOption"))
            .Render();


            ViewContext.Writer.Write(
                    "</div>" +
                    "<div class=\"line\">"
                );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                    edtSettings.Text = "Sort:";
                    edtSettings.AssociatedControlName = "Sort";
                }
            )
            .Render();
            Html.DevExpress().ComboBox(
                edtSettings =>
                {
                    edtSettings.Name = "Sort";
                    edtSettings.Properties.Items.Add("ASC");
                    edtSettings.Properties.Items.Add("DESC");
                    edtSettings.ControlStyle.CssClass = "editor";
                    edtSettings.Properties.TextField = "Sort";
                    edtSettings.Properties.ValueField = "Sort";
                    edtSettings.Properties.ValueType = typeof(string);
                    edtSettings.ShowModelErrors = true;
                }
            )
            .Bind(DataBinder.Eval(user, "Sort"))
            .Render();
            ViewContext.Writer.Write(
                               "</div>" +
                               "<div class=\"line\">"
                           );
            Html.DevExpress().Label(
                edtSettings =>
                {
                    edtSettings.ControlStyle.CssClass = "label";
                }
            )
            .Render();
            Html.DevExpress().Button(
                btnSettings =>
                {
                    btnSettings.Name = "btnUpdate";
                    btnSettings.ControlStyle.CssClass = "button";
                    btnSettings.Text = "Update";
                    btnSettings.ClientSideEvents.Click = "function(s, e){ grdData.UpdateEdit(); }";
                }
            )
            .Render();
            Html.DevExpress().Button(
                btnSettings =>
                {
                    btnSettings.Name = "btnCancel";
                    btnSettings.ControlStyle.CssClass = "button";
                    btnSettings.Text = "Cancel";
                    btnSettings.ClientSideEvents.Click = "function(s, e){ grdData.CancelEdit(); }";
                }
            )
            .Render();
            ViewContext.Writer.Write(
                "</div></div>"
            );
        });

        //settings.PreRender = (sender, e) =>
        //{
        //    ((MVCxGridView)sender).StartEdit(1);
        //};


    });
    if (ViewData["EditError"] != null)
    {
        grid.SetEditErrorText((string)ViewData["EditError"]);
    }
 }
@grid.Bind(Model.GetModel<Portal.Models.DownloadToolsModel>().DataDownloads).GetHtml()
